// fileInfo.cpp: implementation of the fileInfo class.
//
//////////////////////////////////////////////////////////////////////

#include ""
#include "fileInfo.h"

class fileInfo {
public:
	//////////////////////////////////////////////////////////////////////
	// Construction/Destruction
	//////////////////////////////////////////////////////////////////////
	void fileInfo(char* fName)
	{
		fileInfo(fName, 20);
	}

	void fileInfo(char* fName, int size)
	{
		boolVecSize = size;
		fileName = malloc(strlen(fName) + 1);
		strcpy(fileName, fName);
	}

	//----< store names from include statements >---------------------
	//
	//
	void getIncludesFromFile() {
		static ifstream in;			//create once on first entry
		in.open(fileName);
		string line;					// storage for lines read from file
		
		while(in.good()) {
			getline(in,line);
			int pos;
			if(foundHash(line) && foundDelim(line, pos)) {
				string name = extractName(line,pos);
				includeFile.push_back(name);		//save include file names
				if(depMatrix.indexOf(name) == -1)  depMatrix.addFile(name);
				dependOn[depMatrix.indexOf(name)] = true;
			}
		}

		depMatrix.addFile();
		depMatrix.addFile(dependOn);

		in.close();
		in.clear();					//necessary to reuse stream
	}

protected:
	int boolVecSize;
	char* fileName;
	vector <string> includeFiles(boolVecSize);
	vector <bool> dependOn(boolVecSize);

	//----< look for '#' in line >-------------------------------------
	//
	// precondition:
	//   assumes formatted IO was used (getline, not get)
	//   so there is no leading white space

	bool foundHash(const string &line) { return (line[0] == '#'); }

	//----< look for '\"' or '<' in line, return postiion pos >--------

	bool foundDelim(const string &line, int &pos) {
		pos = line.find_first_of('<');
		if(pos == string::npos)
			pos = line.find_first_of('\"');
		return (pos!= string::npos);
	}
}